#include <stdlib.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <stdio.h>
#include <assert.h>

static void * mytest_body(void *dummy) {
        return NULL;
}

int main() {
	struct rlimit rl;
	int retval;
	pthread_t send_thread_id;

        assert(0 == getrlimit(RLIMIT_STACK, &rl));

	printf("RLIM_INFINITY: 0x%x, rl.rlim_cur: 0x%x, rl.rlim_max: 0x%x\n\n",
	       RLIM_INFINITY, rl.rlim_cur, rl.rlim_max);

	rl.rlim_cur =  0x800000; // This works
	rl.rlim_cur =  0x5bee5006; // This works

	// For these values, setrlimit silently accepts the excessively
	//   large stack;  However, this causes a crash later on.
	// rl.rlim_cur =  0x7fb8ffff; // Fails: Not enough memory
	rl.rlim_cur =  0xa0000000; // Fails: Not enough memory
	// rl.rlim_cur =  0xffff0000; // Fails: Not enough memory

	// rl.rlim_cur =  0xffffff00; // allocatestack.c fails
	/* allocatestack.c:404: allocate_stack: Assertion `size != 0' failed.*/
	// rl.rlim_cur =  0xffffffff; // This works

	printf("RLIM_INFINITY: 0x%x, rl.rlim_cur: 0x%x, rl.rlim_max: 0x%x\n\n",
	       RLIM_INFINITY, rl.rlim_cur, rl.rlim_max);
	if (rl.rlim_max != RLIM_INFINITY)
		fprintf(stderr, "WARNING:  rl.rlim_max is not infinity."
				"  The bug may not appear.\n\n");

	if(retval = setrlimit(RLIMIT_STACK, &rl))
		perror("setrlimit");
	assert(0 == retval);

	// This call to pthread_create() does not crash.
	assert( 0 == pthread_create(&send_thread_id, NULL, mytest_body, 0) );

	// A call to pthread_create() in this child process does crash.
	system("./pthread");

	// system("./BUG-raw_saved_prepargcl /home/gene/projects/pargcl/gcl-testing/unixport/ < BUG-init_saved_prepargcl.lsp");
	return 0;

}
